/***********************************************************************/
/***********************************************************************/
/*                                                                     */
/* HIS PROGRAM IS COPYRIGHT 1986 BY LAN ORINKS.  T MAY BE FREELY   */
/* DISTRIBUTED FOR NON COMMERCIAL USAGE IF THIS COPYRIGHT NOTICE IS    */
/* LEFT INTACT. OMMERCIAL USAGE OF THIS PROGRAM IS EXPLICITLY         */
/* FORBIDDEN WITHOUT THE WRITTEN PERMISSION OF THE AUTHOR.             */
/*                                                                     */
/***********************************************************************/
/***********************************************************************/


/*     CDT VERSION 1.0    PART 4 OF 15   ULY 25, 1986                 */


/* PRINT USAGE INSTRUCTION */

#INCLUDE <STDIO.H>
#INCLUDE "DBUG.H"

#DEFINE  9   /* MAX NUMBER OF ERROR INDEX -MUST UPDATE IF ERROR IS ADDED */

STATIC  CHAR    *ERROR[] =

    "UNEVEN NUMBER OF NYBBLES\NUSE LEADING ZEROES!",
    "NO ARGUMENTS",
    "ARGUMENT MUST START WITH DASH",
    "TOO MANY EXECUTABLE COMMANDS",
    "ILLEGAL ARGUMENT",
    "ILLEGAL COMMAND",
    "NON HEX DIGIT",
    "NO COMMANDS",
    "INSUFFICIENT NUMBER OF ARGUMENTS"
 ;

VOID
PRUSAGE(ERR)
    INT ERR ;

    IF ( ERR >=  )
        PRINTF(" \N") ;
    ELSE
        PRINTF("\N%S\N\N",ERROR[ERR]) ;

#IFDEF 80

    PRINTF("USAGE: -P                        PAGE CONTROL OFF.\N") ;
    PRINTF("       -R XXXX YY                READ BYTE AT ADDRESS XXXX IN BANK YY.\N") ;
    PRINTF("       -W XXXX YY ZZ             WRITE BYTE YY AT ADDRESS XXXX IN BANK ZZ\N") ;
    PRINTF("       -B VVVV... XXXX YYYY ZZ   FIND NUMERICAL BYTE STRING,VVVV\N") ;
    PRINTF("                                 IN ADDRESS XXXX THROUGH YYYY IN\N") ;
    PRINTF("                                 BANK ZZ.\N") ;
    PRINTF("       -C %CABC...%C XXXX YYYY ZZ  FIND ALPHA STRING, ABC..., IN ADDRESS\N",'"','"') ;
    PRINTF("                                 XXXX THROUGH YYYY IN BANK ZZ.\N") ;
    PRINTF("       -D XXXX YYYY ZZ           DUMP MEMORY FROM ADDRESS XXXX THROUGH\N") ;
    PRINTF("                                 YYYY IN BANK ZZ\N") ;
    RETURN ;
#ENDIF

#IFDEF 64
    PRINTF("USAGE:\N\N") ;
    PRINTF(" PAGE   -P  PAGING OFF\N") ;
    PRINTF(" READ   -R   \N") ;
    PRINTF(" WRITE  -W    \N") ;
    PRINTF(" FIND   -B  -   \N") ;
    PRINTF(" FIND   -C  %C-%C   \N",'"','"') ;
    PRINTF(" DASMBL -D    \N") ;
    PRINTF(" MEMDMP -M    \N") ;
    RETURN ;
#ENDIF

    /* 128 IN 40 COLUMN MODE */
    PRINTF("USAGE:\N\N") ;
    PRINTF(" PAGE   -P  PAGING OFF\N") ;
    PRINTF(" READ   -R   \N") ;
    PRINTF(" WRITE  -W    \N") ;
    PRINTF(" FIND   -B  -   \N") ;
    PRINTF(" FIND   -C  %C-%C   \N",'"','"') ;
    PRINTF(" DASMBL -D    \N") ;
    PRINTF(" MEMDMP -M    \N") ;


 
