/***********************************************************************/
/***********************************************************************/
/*                                                                     */
/* HIS PROGRAM IS COPYRIGHT 1986 BY LAN ORINKS.  T MAY BE FREELY   */
/* DISTRIBUTED FOR NON COMMERCIAL USAGE IF THIS COPYRIGHT NOTICE IS    */
/* LEFT INTACT. OMMERCIAL USAGE OF THIS PROGRAM IS EXPLICITLY         */
/* FORBIDDEN WITHOUT THE WRITTEN PERMISSION OF THE AUTHOR.             */
/*                                                                     */
/***********************************************************************/
/***********************************************************************/


/*     CDT VERSION 1.0    PART 8 OF 15   ULY 25, 1986                 */


/* DISASSEMBLER OPCODE AND ADDRESSING MODE TABLE */

CHAR *OPCODE[] =

     /*   00    BRK    NONE   */        "BRKC",
     /*   01    ORA    INDX   */        "ORA8",
     /*   02    ???    NONE   */        "???C",
     /*   03    ???    NONE   */        "???C",
     /*   04    ???    NONE   */        "???C",
     /*   05    ORA      ZP   */        "ORA4",
     /*   06    ASL      ZP   */        "ASL4",
     /*   07    ???    NONE   */        "???C",
     /*   08    PHP    NONE   */        "PHPC",
     /*   09    ORA     IMM   */        "ORA0",
     /*   0A    ASL     ACC   */        "ASLB",
     /*   0B    ???    NONE   */        "???C",
     /*   0C    ???    NONE   */        "???C",
     /*   0D    ORA     ABS   */        "ORA1",
     /*   0E    ASL     ABS   */        "ASL1",
     /*   0F    ???    NONE   */        "???C",
     /*   10    BPL     REL   */        "BPLA",
     /*   11    ORA    INDY   */        "ORA9",
     /*   12    ???    NONE   */        "???C",
     /*   13    ???    NONE   */        "???C",
     /*   14    ???    NONE   */        "???C",
     /*   15    ORA     ZPX   */        "ORA5",
     /*   16    ASL     ZPX   */        "ASL5",
     /*   17    ???    NONE   */        "???C",
     /*   18    CLC    NONE   */        "CLCC",
     /*   19    ORA    ABSY   */        "ORA3",
     /*   1A    ???    NONE   */        "???C",
     /*   1B    ???    NONE   */        "???C",
     /*   1C    ???    NONE   */        "???C",
     /*   1D    ORA    ABSX   */        "ORA2",
     /*   1E    ASL    ABSX   */        "ASL2",
     /*   1F    ???    NONE   */        "???C",
     /*   20    JSR     ABS   */        "JSR1",
     /*   21    AND    INDX   */        "AND8",
     /*   22    ???    NONE   */        "???C",
     /*   23    ???    NONE   */        "???C",
     /*   24    BIT      ZP   */        "BIT4",
     /*   25    AND      ZP   */        "AND4",
     /*   26    ROL      ZP   */        "ROL4",
     /*   27    ???    NONE   */        "???C",
     /*   28    PLP    NONE   */        "PLPC",
     /*   29    AND     IMM   */        "AND0",
     /*   2A    ROL     ACC   */        "ROLB",
     /*   2B    ???    NONE   */        "???C",
     /*   2C    BIT     ABS   */        "BIT1",
     /*   2D    AND     ABS   */        "AND1",
     /*   2E    ROL     ABS   */        "ROL1",
     /*   2F    ???    NONE   */        "???C",
     /*   30    BMI     REL   */        "BMIA",
     /*   31    AND    INDY   */        "AND9",
     /*   32    ???    NONE   */        "???C",
     /*   33    ???    NONE   */        "???C",
     /*   34    ???    NONE   */        "???C",
     /*   35    AND     ZPX   */        "AND5",
     /*   36    ROL     ZPX   */        "ROL5",
     /*   37    ???    NONE   */        "???C",
     /*   38    SEC    NONE   */        "SECC",
     /*   39    AND    ABSY   */        "AND3",
     /*   3A    ???    NONE   */        "???C",
     /*   3B    ???    NONE   */        "???C",
     /*   3C    ???    NONE   */        "???C",
     /*   3D    AND    ABSX   */        "AND2",
     /*   3E    ROL    ABSX   */        "ROL2",
     /*   3F    ???    NONE   */        "???C",
     /*   40    RTI    NONE   */        "RTIC",
     /*   41    EOR    INDX   */        "EOR8",
     /*   42    ???    NONE   */        "???C",
     /*   43    ???    NONE   */        "???C",
     /*   44    ???    NONE   */        "???C",
     /*   45    EOR      ZP   */        "EOR4",
     /*   46    LSR      ZP   */        "LSR4",
     /*   47    ???    NONE   */        "???C",
     /*   48    PHA    NONE   */        "PHAC",
     /*   49    EOR     IMM   */        "EOR0",
     /*   4A    LSR     ACC   */        "LSRB",
     /*   4B    ???    NONE   */        "???C",
     /*   4C    JMP     ABS   */        "JMP1",
     /*   4D    EOR     ABS   */        "EOR1",
     /*   4E    LSR     ABS   */        "LSR1",
     /*   4F    ???    NONE   */        "???C",
     /*   50    BVC     REL   */        "BVCA",
     /*   51    EOR    INDY   */        "EOR9",
     /*   52    ???    NONE   */        "???C",
     /*   53    ???    NONE   */        "???C",
     /*   54    ???    NONE   */        "???C",
     /*   55    EOR     ZPX   */        "EOR5",
     /*   56    LSR     ZPX   */        "LSR5",
     /*   57    ???    NONE   */        "???C",
     /*   58    CLI    NONE   */        "CLIC",
     /*   59    EOR    ABSY   */        "EOR3",
     /*   5A    ???    NONE   */        "???C",
     /*   5B    ???    NONE   */        "???C",
     /*   5C    ???    NONE   */        "???C",
     /*   5D    EOR    ABSX   */        "EOR2",
     /*   5E    LSR    ABSX   */        "LSR2",
     /*   5F    ???    NONE   */        "???C",
     /*   60    RTS    NONE   */        "RTSC",
     /*   61    ADC    INDX   */        "ADC8",
     /*   62    ???    NONE   */        "???C",
     /*   63    ???    NONE   */        "???C",
     /*   64    ???    NONE   */        "???C",
     /*   65    ADC      ZP   */        "ADC4",
     /*   66    ROR      ZP   */        "ROR4",
     /*   67    ???    NONE   */        "???C",
     /*   68    PLA    NONE   */        "PLAC",
     /*   69    ADC     IMM   */        "ADC0",
     /*   6A    ROR     ACC   */        "RORB",
     /*   6B    ???    NONE   */        "???C",
     /*   6C    JMP     IND   */        "JMP7",
     /*   6D    ADC     ABS   */        "ADC1",
     /*   6E    ROR     ABS   */        "ROR1",
     /*   6F    ???    NONE   */        "???C",
     /*   70    BVS     REL   */        "BVSA",
     /*   71    ADC    INDY   */        "ADC9",
     /*   72    ???    NONE   */        "???C",
     /*   73    ???    NONE   */        "???C",
     /*   74    ???    NONE   */        "???C",
     /*   75    ADC     ZPX   */        "ADC5",
     /*   76    ROR     ZPX   */        "ROR5",
     /*   77    ???    NONE   */        "???C",
     /*   78    SEI    NONE   */        "SEIC",
     /*   79    ADC    ABSY   */        "ADC3",
     /*   7A    ???    NONE   */        "???C",
     /*   7B    ???    NONE   */        "???C",
     /*   7C    ???    NONE   */        "???C",
     /*   7D    ADC    ABSX   */        "ADC2",
     /*   7E    ROR    ABSX   */        "ROR2",
     /*   7F    ???    NONE   */        "???C",
     /*   80    ???    NONE   */        "???C",
     /*   81    STA    INDX   */        "STA8",
     /*   82    ???    NONE   */        "???C",
     /*   83    ???    NONE   */        "???C",
     /*   84    STY      ZP   */        "STY4",
     /*   85    STA      ZP   */        "STA4",
     /*   86    STX      ZP   */        "STX4",
     /*   87    ???    NONE   */        "???C",
     /*   88    DEY    NONE   */        "DEYC",
     /*   89    ???    NONE   */        "???C",
     /*   8A    TXA    NONE   */        "TXAC",
     /*   8B    ???    NONE   */        "???C",
     /*   8C    STY     ABS   */        "STY1",
     /*   8D    STA     ABS   */        "STA1",
     /*   8E    STX     ABS   */        "STX1",
     /*   8F    ???    NONE   */        "???C",
     /*   90    BCC     REL   */        "BCCA",
     /*   91    STA    INDY   */        "STA9",
     /*   92    ???    NONE   */        "???C",
     /*   93    ???    NONE   */        "???C",
     /*   94    STY     ZPX   */        "STY5",
     /*   95    STA     ZPX   */        "STA5",
     /*   96    STX     ZPY   */        "STX6",
     /*   97    ???    NONE   */        "???C",
     /*   98    TYA    NONE   */        "TYAC",
     /*   99    STA    ABSY   */        "STA3",
     /*   9A    TXS    NONE   */        "TXSC",
     /*   9B    ???    NONE   */        "???C",
     /*   9C    ???    NONE   */        "???C",
     /*   9D    STA    ABSX   */        "STA2",
     /*   9E    ???    NONE   */        "???C",
     /*   9F    ???    NONE   */        "???C",
     /*   A0    LDY     IMM   */        "LDY0",
     /*   A1    LDA    INDX   */        "LDA8",
     /*   A2    LDX     IMM   */        "LDX0",
     /*   A3    ???    NONE   */        "???C",
     /*   A4    LDY      ZP   */        "LDY4",
     /*   A5    LDA      ZP   */        "LDA4",
     /*   A6    LDX      ZP   */        "LDX4",
     /*   A7    ???    NONE   */        "???C",
     /*   A8    TAY    NONE   */        "TAYC",
     /*   A9    LDA     IMM   */        "LDA0",
     /*   AA    TAX    NONE   */        "TAXC",
     /*   AB    ???    NONE   */        "???C",
     /*   AC    LDY     ABS   */        "LDY1",
     /*   AD    LDA     ABS   */        "LDA1",
     /*   AE    LDX     ABS   */        "LDX1",
     /*   AF    ???    NONE   */        "???C",
     /*   B0    BCS     REL   */        "BCSA",
     /*   B1    LDA    INDY   */        "LDA9",
     /*   B2    ???    NONE   */        "???C",
     /*   B3    ???    NONE   */        "???C",
     /*   B4    LDY    NONE   */        "LDYC",
     /*   B5    LDA     ZPX   */        "LDA5",
     /*   B6    LDX     ZPY   */        "LDX6",
     /*   B7    ???    NONE   */        "???C",
     /*   B8    CLV    NONE   */        "CLVC",
     /*   B9    LDA    ABSY   */        "LDA3",
     /*   BA    TSX    NONE   */        "TSXC",
     /*   BB    ???    NONE   */        "???C",
     /*   BC    LDY    ABSX   */        "LDY2",
     /*   BD    LDA    ABSX   */        "LDA2",
     /*   BE    LDX    ABSY   */        "LDX3",
     /*   BF    ???    NONE   */        "???C",
     /*   C0    CPY     IMM   */        "CPY0",
     /*   C1    CMP    INDX   */        "CMP8",
     /*   C2    ???    NONE   */        "???C",
     /*   C3    ???    NONE   */        "???C",
     /*   C4    CPY      ZP   */        "CPY4",
     /*   C5    CMP      ZP   */        "CMP4",
     /*   C6    DEC      ZP   */        "DEC4",
     /*   C7    ???    NONE   */        "???C",
     /*   C8    INY    NONE   */        "INYC",
     /*   C9    CMP     IMM   */        "CMP0",
     /*   CA    DEX    NONE   */        "DEXC",
     /*   CB    ???    NONE   */        "???C",
     /*   CC    CPY     ABS   */        "CPY1",
     /*   CD    CMP     ABS   */        "CMP1",
     /*   CE    DEC     ABS   */        "DEC1",
     /*   CF    ???    NONE   */        "???C",
     /*   D0    BNE     REL   */        "BNEA",
     /*   D1    CMP    INDY   */        "CMP9",
     /*   D2    ???    NONE   */        "???C",
     /*   D3    ???    NONE   */        "???C",
     /*   D4    ???    NONE   */        "???C",
     /*   D5    CMP     ZPX   */        "CMP5",
     /*   D6    DEC     ZPX   */        "DEC5",
     /*   D7    ???    NONE   */        "???C",
     /*   D8    CLD    NONE   */        "CLDC",
     /*   D9    CMP    ABSY   */        "CMP3",
     /*   DA    ???    NONE   */        "???C",
     /*   DB    ???    NONE   */        "???C",
     /*   DC    ???    NONE   */        "???C",
     /*   DD    CMP    ABSX   */        "CMP2",
     /*   DE    DEC    ABSX   */        "DEC2",
     /*   DF    ???    NONE   */        "???C",
     /*   E0    CPX     IMM   */        "CPX0",
     /*   E1    SBC    INDX   */        "SBC8",
     /*   E2    ???    NONE   */        "???C",
     /*   E3    ???    NONE   */        "???C",
     /*   E4    CPX      ZP   */        "CPX4",
     /*   E5    SBC      ZP   */        "SBC4",
     /*   E6    INC      ZP   */        "INC4",
     /*   E7    ???    NONE   */        "???C",
     /*   E8    INX    NONE   */        "INXC",
     /*   E9    SBC     IMM   */        "SBC0",
     /*   EA    NOP    NONE   */        "NOPC",
     /*   EB    ???    NONE   */        "???C",
     /*   EC    CPX     ABS   */        "CPX1",
     /*   ED    SBC     ABS   */        "SBC1",
     /*   EE    INC     ABS   */        "INC1",
     /*   EF    ???    NONE   */        "???C",
     /*   F0    BEQ     REL   */        "BEQA",
     /*   F1    SBC    INDY   */        "SBC9",
     /*   F2    ???    NONE   */        "???C",
     /*   F3    ???    NONE   */        "???C",
     /*   F4    ???    NONE   */        "???C",
     /*   F5    SBC     ZPX   */        "SBC5",
     /*   F6    INC     ZPX   */        "INC5",
     /*   F7    ???    NONE   */        "???C",
     /*   F8    SED    NONE   */        "SEDC",
     /*   F9    SBC    ABSY   */        "SBC3",
     /*   FA    ???    NONE   */        "???C",
     /*   FB    ???    NONE   */        "???C",
     /*   FC    ???    NONE   */        "???C",
     /*   FD    SBC    ABSX   */        "SBC2",
     /*   FE    INC    ABSX   */        "INC2",
     /*   FF    ???    NONE   */        "???C"
 ;
 
